#include <Rcpp.h>
using namespace Rcpp;

// [[Rcpp::export]]
NumericMatrix bootHD(NumericMatrix x, int B = 10000) {
	int n = x.nrow();
	int p = x.ncol();

	NumericMatrix bootstats(2 * B, p);

	for (int i = 0; i < B; i++) {
		NumericVector bootid = floor(runif(n, 0, n));

			for (int j = 0; j < p; j++) {
				NumericVector xj = x(_, j);
				NumericVector xboot = xj[bootid];
				bootstats(i, j) = mean(xboot);
				bootstats(B + i, j) = sd(xboot);
			}
	}

	return(bootstats);
}